def process_each(process, file_names):
  import traceback
  n_fail = 0
  n_succ = 0
  for file_name in file_names:
    try:
      process(file_names=[file_name])
    except Exception:
      n_fail += 1
      print "FAILING:", file_name
      print traceback.format_exc(limit=None)
    else:
      n_succ += 1
  if (n_fail != 0):
    print "Failing:", n_fail
  if (n_succ != 0):
    print "Success:", n_succ

def run(args):
  if (len(args) == 0): args = ["--help"]
  from libtbx.option_parser import option_parser
  import libtbx.load_env
  command_line = (option_parser(
    usage="%s [options] fortran_file ..." % libtbx.env.dispatcher_name)
    .option(None, "--each",
      action="store_true",
      default=False)
  ).process(args=args)
  co = command_line.options
  from fable.read import process
  if (co.each):
    process_each(process=process, file_names=command_line.args)
  else:
    process(file_names=command_line.args)

if (__name__ == "__main__"):
  import sys
  run(args=sys.argv[1:])
