#ifndef FEM_ARRAY_HPP
#define FEM_ARRAY_HPP

#include <fem/ref.hpp>
#include <fem/zero.hpp>

namespace fem {

  template <typename T, size_t Ndims=1>
  struct array : ref<T, Ndims>
  {
    private:
      array(
        array const&);

      array&
      operator=(
        array const&);

      public:

    explicit
    array(
      dim_buffer const& dims)
    {
      (*this)(dims);
      this->elems_ = new T[this->size_1d()];
    }

    array(
      dim_buffer const& dims,
      fill0_type const&)
    {
      (*this)(dims);
      this->elems_ = new T[this->size_1d()];
      this->fill(0);
    }

    ~array()
    {
      delete[] this->elems_;
    }
  };

} // namespace fem

#endif // GUARD
