#ifndef FEM_INQUIRE_CHAIN_DECL_HPP
#define FEM_INQUIRE_CHAIN_DECL_HPP

#include <fem/str_ref.hpp>
#include <stdexcept>

namespace fem {

  struct inquire_err : std::runtime_error
  {
    explicit
    inquire_err(std::string const& msg) : std::runtime_error(msg) {}
  };

  struct inquire_chain
  {
    struct io* io_ptr;
    int unit;
    std::string file;
    bool have_file;

    inline
    inquire_chain(
      io* io_ptr_,
      int unit_);

    inline
    inquire_chain(
      io* io_ptr_,
      std::string const& file);

    inline
    ~inquire_chain();

    inline
    inquire_chain&
    iostat(
      int& val);

    inline
    inquire_chain&
    exist(
      bool& val);

    inline
    inquire_chain&
    opened(
      bool& val);

    inline
    inquire_chain&
    number(
      int& val);

    inline
    inquire_chain&
    named(
      bool& val);

    inline
    inquire_chain&
    name(
      str_ref val);

    inline
    inquire_chain&
    access(
      str_ref val);

    inline
    inquire_chain&
    sequential(
      str_ref val);

    inline
    inquire_chain&
    direct(
      str_ref val);

    inline
    inquire_chain&
    form(
      str_ref val);

    inline
    inquire_chain&
    formatted(
      str_ref val);

    inline
    inquire_chain&
    unformatted(
      str_ref val);

    inline
    inquire_chain&
    recl(
      int& val);

    inline
    inquire_chain&
    nextrec(
      int& val);

    inline
    inquire_chain&
    blank(
      str_ref val);
  };

} // namespace fem

#endif // GUARD
