#ifndef FEM_OPEN_CHAIN_DECL_HPP
#define FEM_OPEN_CHAIN_DECL_HPP

#include <stdexcept>
#include <string>

namespace fem {

  struct open_err : std::runtime_error
  {
    explicit
    open_err(std::string const& msg) : std::runtime_error(msg) {}
  };

  struct open_chain
  {
    struct io* io_ptr;
    int unit;

    inline
    open_chain(
      io* io_ptr_,
      int unit_);

    inline
    ~open_chain();

    inline
    open_chain&
    access(
      std::string const& val);

    inline
    open_chain&
    form(
      std::string const& val);

    inline
    open_chain&
    recl(
      int const& val);

    inline
    open_chain&
    blank(
      std::string const& val);

    inline
    open_chain&
    status(
      std::string const& val);

    inline
    open_chain&
    iostat(
      int& val);
  };

} // namespace fem

#endif // GUARD
