#ifndef FEM_OPEN_CHAIN_DEFS_HPP
#define FEM_OPEN_CHAIN_DEFS_HPP

#include <fem/io.hpp>

namespace fem {

  inline
  open_chain::open_chain(
    io* io_ptr_,
    int unit_)
  :
    io_ptr(io_ptr_),
    unit(unit_)
  {}

  inline
  open_chain::~open_chain()
  {
    // TODO
    // recl must be given when a file is being connected for
    // direct access; otherwise, it  must be omitted.
  }

  inline
  open_chain&
  open_chain::access(
    std::string const& /*val*/)
  {
    // static const char* valid_vals[] = {"sequential", "direct"};
    // TODO
    return *this;
  }

  inline
  open_chain&
  open_chain::form(
    std::string const& /*val*/)
  {
    // static const char* valid_vals[] = {"formatted", "unformatted"};
    // TODO
    return *this;
  }

  inline
  open_chain&
  open_chain::recl(
    int const& val)
  {
    if (val <= 0) {
      throw std::runtime_error(
        "Invalid OPEN RECL: value is zero or negative,"
        " but must be greater than zero");
    }
    // TODO
    return *this;
  }

  inline
  open_chain&
  open_chain::blank(
    std::string const& /*val*/)
  {
    // static const char* valid_vals[] = {"null", "zero"};
    // TODO
    return *this;
  }

  inline
  open_chain&
  open_chain::status(
    std::string const& /*val*/)
  {
    // static const char* valid_vals[] = {"old", "new", "scratch", "unknown"};
    // TODO
    return *this;
  }

  inline
  open_chain&
  open_chain::iostat(
    int& /*val*/)
  {
    // TODO
    return *this;
  }

} // namespace fem

#endif // GUARD
